



library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library proc_common_v1_00_b;
use proc_common_v1_00_b.proc_common_pkg.all;

entity vector_proc_32 is
 port (
DO: out std_logic_vector(31 downto 0);
ADDR: in std_logic_vector(31 downto 0);
DI: in std_logic_vector(31 downto 0);
EN: in std_logic_vector(0 downto 0);
WE: in std_logic_vector(0 downto 0);
REG_IN_A: in std_logic_vector(31 downto 0);
REG_IN_B: in std_logic_vector(31 downto 0);
REG_OUT_A: out std_logic_vector(31 downto 0);
REG_OUT_B: out std_logic_vector(31 downto 0);
REG_WE_A: in std_logic_vector(0 downto 0);
REG_WE_B: in std_logic_vector(0 downto 0);
Clk: in std_logic;
Reset: in std_logic

);
end vector_proc_32;
architecture IMP of vector_proc_32 is

  component HI_RAMB
   generic (
	data_width: integer;
	address_width: integer;
	depth: integer
	);
   port (
	doa: out std_logic_vector(data_width-1 downto 0);
	dob: out std_logic_vector(data_width-1 downto 0);
	addra: in std_logic_vector(address_width-1 downto 0);
	addrb: in std_logic_vector(address_width-1 downto 0);
	clka: in std_ulogic;
	clkb: in std_ulogic;
	dia: in std_logic_vector(data_width-1 downto 0);
	dib: in std_logic_vector(data_width-1 downto 0);
	rsta: in std_ulogic;
	rstb: in std_ulogic;
	wea: in std_ulogic;
	web: in std_ulogic
	);
  end component;


	signal a: std_logic_vector( 31 downto 0 );
	signal b: std_logic_vector( 31 downto 0 );
	signal sum: std_logic_vector( 31 downto 0 );

   component  summator
	port (   
     add1     : in  std_logic_vector(31 downto 0);
     add2     : in  std_logic_vector(31 downto 0);
     result   : out  std_logic_vector(31 downto 0);
     Clk      : in  std_logic;	
     Reset    : in  std_logic   
         );      
   end component;


begin

REG_OUT_A <= sum;

   COMPONENT1: summator
	port map (
	add1 => a,
	add2 => b,
	result => sum,
	Clk => Clk,
	Reset => Reset
	 );

STATE_PROC: process ( Clk ) is
  variable stage: integer := 0;
begin
 if ( Clk'event and Clk = '1' ) then
  if ( Reset = '1' ) then
a <= "00000000000000000000000000000000";
b <= "00000000000000000000000000000000";
else
if (REG_WE_A = "1") then
a <= REG_IN_A;
end if;
if (REG_WE_B = "1") then
b <= REG_IN_B;
end if;
  end if;
 end if;
end process STATE_PROC;
end IMP;
library ieee;                                                
use ieee.std_logic_1164.all;                                 
use ieee.std_logic_arith.all;                                
use ieee.std_logic_unsigned.all;                             
                                                             
library proc_common_v1_00_b;                                 
use proc_common_v1_00_b.proc_common_pkg.all;                 
                                                             
entity summator is                                           
 port (                                                      
add1: in std_logic_vector(31 downto 0);                      
add2: in std_logic_vector(31 downto 0);                      
result: out std_logic_vector(31 downto 0);                   
Clk: in std_logic;                                           
Reset: in std_logic                                          
                                                             
);                                                           
end summator;                                                
architecture IMP1 of summator is                              
                                                             
  component HI_RAMB                                          
   generic (                                                 
	data_width: integer;                                 
	address_width: integer;                              
	depth: integer                                       
	);                                                   
   port (                                                    
	doa: out std_logic_vector(data_width-1 downto 0);    
	dob: out std_logic_vector(data_width-1 downto 0);    
	addra: in std_logic_vector(address_width-1 downto 0);
	addrb: in std_logic_vector(address_width-1 downto 0);
	clka: in std_ulogic;                                 
	clkb: in std_ulogic;                                 
	dia: in std_logic_vector(data_width-1 downto 0);     
	dib: in std_logic_vector(data_width-1 downto 0);     
	rsta: in std_ulogic;                                 
	rstb: in std_ulogic;                                 
	wea: in std_ulogic;                                  
	web: in std_ulogic                                   
	);                                                   
  end component;                                             
                                                             
                                                             
                                                             
begin                                                        
                                                             
                                                             
STATE_PROC: process ( Clk ) is                               
  variable stage: integer := 0;                              
begin                                                        
 if ( Clk'event and Clk = '1' ) then                         
  if ( Reset = '1' ) then                                    
result <= "00000000000000000000000000000000";                
else                                                         
result <= add1+add2;                                         
  end if;                                                    
 end if;                                                     
end process STATE_PROC;                                      
end IMP1;                                                     